local Nskin = {}

--Defining on which direction the other directions should be bassed on
--This will let us use less files which is quite handy to keep the noteskin directory nice
--Do remember this will Redirect all the files of that Direction to the Direction its pointed to
--If you only want some files to be redirected take a look at the "custom hold/roll per direction"
Nskin.ButtonRedir =
{	
	--Dance
	Down = "1",
	Up = "2",
	Left = "2",
	Right = "1",
	
	--iidx
	Key1 = "1",
	Key2 = "2",
	Key3 = "1",
	Key4 = "2",
	Key5 = "1",
	Key6 = "2",
	Key7 = "1",
	scratch = "scratch",
	Foot = "foot",
	
	--popn
	["Left White"] = "White",
	["Left Yellow"] = "Yellow",
	["Left Green"] = "Green",
	["Left Blue"] = "Blue",
	Red = "Red",
	["Right Blue"] = "Blue",
	["Right Green"] = "Green",
	["Right Yellow"] = "Yellow",
	["Right White"] = "White",
}

--These define what key goes to which "Arrow" for KBX mode.
Nskin.KBXRedir =
{
	{Key10="scratch"},
	{Key9="1", Key11="1"},
	{Key9="1", Key10="scratch", Key11="1"},
	{Key7="2", Key9="1", Key11="1", Key13="2"},
	{Key7="2", Key9="1", Key10="scratch", Key11="1", Key13="2"},
	{Key5="1", Key7="2", Key9="1", Key11="1", Key13="2", Key15="1"},
	{Key5="1", Key7="2", Key9="1", Key10="scratch", Key11="1", Key13="2", Key15="1"},
	{Key3="2", Key5="1", Key7="2", Key9="1", Key11="1", Key13="2", Key15="1", Key17="2"},
	{Key3="2", Key5="1", Key7="2", Key9="1", Key10="scratch", Key11="1", Key13="2", Key15="1", Key17="2"},
	{Key3="1", Key4="2", Key5="1", Key7="2", Key9="1", Key11="1", Key13="2", Key15="1", Key16="2", Key17="1"},
	{Key3="1", Key4="2", Key5="1", Key7="2", Key9="1", Key10="scratch", Key11="1", Key13="2", Key15="1", Key16="2", Key17="1"},
	{Key3="2", Key4="1", Key5="2", Key7="1", Key8="2", Key9="1", Key11="1", Key12="2", Key13="1", Key15="2", Key16="1", Key17="2"},
	{Key3="2", Key4="1", Key5="2", Key7="1", Key8="2", Key9="1", Key10="scratch", Key11="1", Key12="2", Key13="1", Key15="2", Key16="1", Key17="2"},
	{Key3="1", Key4="2", Key5="1", Key6="2", Key7="1", Key8="2", Key9="1", Key11="1", Key12="2", Key13="1", Key14="2", Key15="1", Key16="2", Key17="1"},
	{Key3="1", Key4="2", Key5="1", Key6="2", Key7="1", Key8="2", Key9="1", Key10="scratch", Key11="1", Key12="2", Key13="1", Key14="2", Key15="1", Key16="2", Key17="1"},
	{Key2="2", Key3="1", Key4="2", Key5="1", Key6="2", Key7="1", Key8="2", Key9="1", Key11="1", Key12="2", Key13="1", Key14="2", Key15="1", Key16="2", Key17="1", Key18="2"},
	{Key2="2", Key3="1", Key4="2", Key5="1", Key6="2", Key7="1", Key8="2", Key9="1", Key10="scratch", Key11="1", Key12="2", Key13="1", Key14="2", Key15="1", Key16="2", Key17="1", Key18="2"},
	{Key1="1", Key2="2", Key3="1", Key4="2", Key5="1", Key6="2", Key7="1", Key8="2", Key9="1", Key11="1", Key12="2", Key13="1", Key14="2", Key15="1", Key16="2", Key17="1", Key18="2", Key19="1"},
	{Key1="1", Key2="2", Key3="1", Key4="2", Key5="1", Key6="2", Key7="1", Key8="2", Key9="1", Key10="scratch", Key11="1", Key12="2", Key13="1", Key14="2", Key15="1", Key16="2", Key17="1", Key18="2", Key19="1"},
}

Nskin.Game = GAMESTATE:GetCurrentGame():GetName()

--Define elements that need to be redirected
Nskin.ElementRedir =
{
	["Tap Explosion Dim"] = "Tap Explosion Bright",
	["Hold Explosion"] = "Tap Explosion Bright",
	["Roll Explosion"] = "Tap Explosion Bright",
}

-- Parts of noteskins which we want to rotate
Nskin.PartsToRotate =
{
}

-- Parts that should be Redirected to _Blank.png
-- you can add/remove stuff if you want
Nskin.Blank =
{
	["HitMine Explosion"] = true,
	["Hold Tail Active"] = true,
	["Hold Tail Inactive"] = true,
	["Roll Tail Active"] = true,
	["Roll Tail Inactive"] = true,
	["Hold Bottomcap Inactive"] = true,
	["Hold Topcap Inactive"] = true,
	["Hold Topcap Active"] = true
}

--Between here we usally put all the commands the noteskin.lua needs to do, some are extern in other files
--If you need help with lua go to https://josevarela.xyz/Luadoc/Lua.xml there are a bunch of codes there
--Also check out common it has a load of lua codes in files there
--Just play a bit with lua its not that hard if you understand coding
--But SM can be an ass in some cases, and some codes jut wont work if you dont have the noteskin on FallbackNoteSkin=common in the metric.ini 
function Nskin.Load()
	local sButton = Var "Button"
	local sElement = Var "Element"
	--Setting global button
	local Button = Nskin.ButtonRedir[sButton] or "1"

	if Nskin.Game == 'kbx' then
		local numCols = GAMESTATE:GetCurrentStyle():ColumnsPerPlayer()
		if Nskin.KBXRedir[numCols] then
			Button = Nskin.KBXRedir[numCols][sButton] or "scratch"
		else -- In case we get extra buttons somehow.
			Button = "scratch"
		end
	end
		
	--Setting global element
	local Element = Nskin.ElementRedir[sElement] or sElement
	
	if string.find(sElement, "Explosion") then
		Button = "1"
	end

	if string.find(sElement, "Head") or string.find(sElement, "Fake") then
		Element = "Tap Note"
	end
	
	if string.find(Element, "Mine") then Button = "Down" end
			
	--Returning first part of the code, The redirects, Second part is for commands
	local t = LoadActor(NOTESKIN:GetPath(Button,Element))
		
	--Set blank redirects
	if Nskin.Blank[sElement] then
		t = Def.Actor {}
		--Check if element is sprite only
		if Var "SpriteOnly" then
			t = LoadActor(NOTESKIN:GetPath("","_blank"))
		end
	end
	
	if Nskin.PartsToRotate[sElement] then
		t.BaseRotationZ = Nskin.Rotate[sButton] or nil
	end
			
	return t
end
-- >

-- dont forget to return cuz else it wont work >
return Nskin
