local GridData = ...
local cursorPositions = GridData.cursorPositions
local selectionCursor = {1,1}

if GridData.selectionCursor then
	selectionCursor = GridData.selectionCursor
end

local function isAtOption( nameOption )
	local choice = cursorPositions[ selectionCursor[1] ][selectionCursor[2] ]
	if not choice then return false end
	if not choice.name then return false end

	return choice.name:lower() == nameOption:lower()
end

local function CheckBoundry(offset)
	selectionCursor[1] = selectionCursor[1] + offset[1]
	selectionCursor[2] = selectionCursor[2] + offset[2]

	-- If the option contains a special skip option, jump to that.
	if cursorPositions[selectionCursor[1]] and cursorPositions[selectionCursor[1]].DownSkip then
		selectionCursor[1] = cursorPositions[selectionCursor[1]].DownSkip
	end

	local limitY = #cursorPositions
	if selectionCursor[1] > limitY then selectionCursor[1] = limitY end
	if selectionCursor[1] < 1 then selectionCursor[1] = 1 end

	if selectionCursor[2] < 1 then selectionCursor[2] = 1 end
	local limitX = #cursorPositions[selectionCursor[1]]
	if selectionCursor[2] > limitX then selectionCursor[2] = limitX end
end

local function changeCursorPos(newpos)
	selectionCursor = newpos
	CheckBoundry({0,0})
	return selectionCursor
end

local quad = Def.Quad{
	InitCommand=function(self)
		self:diffuse(Alpha(Color.White, 0.25))
		:xy( cursorPositions[1][1][1], cursorPositions[1][1][2] )
	end,
	MoveCursorCommand=function(self,params)
		local newPos = cursorPositions[ selectionCursor[1] ][ selectionCursor[2] ]
		self:stoptweening():easeoutexpo(0.1):xy( newPos[1], newPos[2] )
		:zoomto( newPos[3], newPos[4] )
		:diffusealpha( newPos[5] or 0.25 )
	end
}

return CheckBoundry, quad, changeCursorPos, selectionCursor, isAtOption
