local Args = ...
local widthset = Args.Width
local States = Args.States
local heightblock = 300
local t = Def.ActorFrame{}

local moreThanAPlayer = GAMESTATE:GetNumPlayersEnabled() > 1
for k,v in ipairs( GAMESTATE:GetEnabledPlayers() ) do
	local InfoBG = LoadModule("UI/UI.ButtonBox.lua")(widthset,heightblock,2,nil,true)
	local PInfo = LoadModule("Options.GetProfileData.lua")(v)
	
	-- Add Player info
	t[#t+1] = Def.ActorFrame{
		InitCommand=function(self)
			self:xy( SCREEN_CENTER_X, SCREEN_CENTER_Y-100 )
			if moreThanAPlayer then
				self:x( SCREEN_CENTER_X + (v == PLAYER_1 and -230 or 230)  )
			end
		end,
		OnCommand=function(self)
			local pinfoAF = self:GetChild("PlayerInfo"):GetChildren()
			pinfoAF.PlayerImage:Load( PInfo.Image ):setsize(86,86)
			pinfoAF.PlayerName:settext( PInfo.Name )
		end,
		InfoBG:Create(),

		Def.ActorFrame{
			Name="PlayerInfo",
			InitCommand=function(self)
				self:halign(0):xy( -widthset*.5 + 60, -heightblock*.325 )
			end,

			Def.Sprite{ Name="PlayerImage" },
			Def.BitmapText{
				Font="Common Normal",
				Name="PlayerName",
				InitCommand=function(self)
					self:halign(0):x( 60 )
				end
			}
		},

		LoadActor("./GoalMenu.lua", {Width = widthset*.5 + 42, Player = v, States = States})
	}
end

return t