local needsStats = ...

-- Initalize
local LoadHUD = Def.ActorFrame{}

-- Load common objects
LoadHUD[#LoadHUD+1] = Def.ActorFrame {
	InitCommand=function(self)
		--local ScaleItems = SCREEN_WIDTH <= 480 and scale( SCREEN_WIDTH, 420, 920, 0.5, 0.8 )
		local pn = GAMESTATE:GetMasterPlayerNumber()
		local isCentered = Center1Player() or GAMESTATE:GetIsFieldCentered(pn)
		self:x(isCentered and _screen.cx+200 or _screen.cx):y(50):valign(1)
		local pos = {
			["StyleType_OnePlayerTwoSides"] = 280,
		}
		if (GAMESTATE:GetNumPlayersEnabled() == 1 and isCentered) or pos[GAMESTATE:GetCurrentStyle():GetStyleType()] then
			local position = pos[GAMESTATE:GetCurrentStyle():GetStyleType()] or 200
			local xoffset = (pn == PLAYER_1 and position or -position)

			self:x( _screen.cx + (needsStats and 290 or xoffset) )
		end
		-- is the player in reverse? Move it.
		if (not needsStats) and GAMESTATE:GetPlayerState(pn):GetPlayerOptions("ModsLevel_Preferred"):Reverse() > 0.5 then
			self:y( SCREEN_BOTTOM-50 )
		end
		if GetScreenAspectRatio() < 1 then
			self:x( SCREEN_WIDTH*.85 ):zoom(scale( SCREEN_WIDTH, 420, 540, 0.7, 0.8 ))
		end
	end,
	Def.Sprite{
		Name="Base",
		Texture=THEME:GetPathG("","Gameplay/HUD"),
		OnCommand=function(self)
			self:zoom(1.45):diffuse( GameColor.Custom["HUDBGColor"] )
		end
	},
	Def.SongMeterDisplay{
        OnCommand=function(self)
        	self:SetStreamWidth( self:GetParent():GetChild("Base"):GetZoomedWidth() )
			:y( -self:GetParent():GetChild("Base"):GetZoomedHeight()*.5 + 10 )
        end,
        Stream=Def.Quad{ 
        	InitCommand=function(self) self:zoomtoheight(16):diffuse( GameColor.Custom["TotalTimerMeterColor"] ) end
        },
        Tip=Def.ActorFrame{},
	},

	Def.Sprite{
		Texture=THEME:GetPathG("","Gameplay/borderHUD"),
		OnCommand=function(self)
			self:zoom(1.45):diffuse( GameColor.Custom["HUDBorderColor"] )
		end
	},

	LoadModule("Gameplay/bpmDisplay.lua")..{
		InitCommand=function(self) self:zoom(0.8):y(8) end
	},
	LoadModule("Gameplay/totalTimer.lua")..{
		InitCommand=function(self)
			self:zoom(0.7)
			:y( -self:GetParent():GetChild("Base"):GetZoomedHeight()*.5 + 2 )
			:diffuse( GameColor.Custom["TotalTimerTextColor"] )
			:shadowlength(2)
		end
	}
}

local validForStats = GAMESTATE:GetNumPlayersEnabled() == 1 and GAMESTATE:GetCurrentStyle():GetStyleType() ~= "StyleType_OnePlayerTwoSides"
if ((not needsStats and validForStats) or GAMESTATE:GetNumPlayersEnabled() > 1) then
	LoadHUD[#LoadHUD+1] = LoadModule("Gameplay/songInfo.lua")..{
		InitCommand=function(self) self:xy( SCREEN_CENTER_X,SCREEN_BOTTOM-40 ):diffusealpha(0) end,
		OnCommand=function(self)
			if GAMESTATE:GetPlayerState(GAMESTATE:GetMasterPlayerNumber()):GetPlayerOptions("ModsLevel_Preferred"):Reverse() > 0.5 then
				self:y( 40 )
			end
			self:sleep(0.2):linear(0.2):diffusealpha(0.6)
		end
	}
end

return LoadHUD