-- This is a counter that measures how off you're from the perfect score (100%).
local Args = ...
local Player = Args.pn
local Settings = Args.settings

return Def.BitmapText{
    Font="_Plex Bold Large",
    OnCommand=function(self)
        local p = SCREENMAN:GetTopScreen():GetChild("PlayerP"..string.sub(Player,-1))
		local yStandard = THEME:GetMetric("Player","ReceptorArrowsYStandard")
		local yReverse = THEME:GetMetric("Player","ReceptorArrowsYReverse")
		
		local function yReceptorScale(val)
			return scale( val, 0, 1, yStandard, yReverse )
		end

		self:shadowlength(1):zoom(.6):diffuse( ColorLightTone(Color.Purple) )
		:halign(1)
		
        -- Before we send out the actor to start it's job, vertical screens might mess up the scaling of this actor,
		-- so update accordingly.
		:zoom( p:GetBaseZoomX() * .6 )
		:x( p:GetX() + GAMESTATE:GetStyleFieldSize(Player)*.7 )
		:y(
			p:GetY() + yReceptorScale( GAMESTATE:GetPlayerState(Player):GetCurrentPlayerOptions():Reverse() )
		)
    end,
    JudgmentMessageCommand=function(self,param)
        if param.Player == Player then
            -- We need to obtain the stats, and then convert that over to a division.
			-- This division will be the ammount that we have missed.
			local stats = STATSMAN:GetCurStageStats():GetPlayerStageStats(Player)
			if stats then
				local calc = stats:GetCurrentPossibleDancePoints() - stats:GetActualDancePoints()
				local newmiss = (( stats:GetPossibleDancePoints() - calc ) / stats:GetPossibleDancePoints())
				-- Don't show anything if there isn't a discrepancy with the score yet.
				if newmiss == 1 then return end
				self:settext( "-"..FormatPercentScore(1 - newmiss) )
			end
        end
    end
}