-- PaceMaker: Performs calculations based on the possible and achieved score from the player.
local Args = ...
local Player = Args.Player
local barHeight = Args.BarHeight or 600
local barWidth = Args.BarWidth or 64
-- local target = 1
local target = 1
local targetName = "TARGET"
if GAMESTATE:Env()["ScoreTargets"] and GAMESTATE:Env()["ScoreTargets"][Player]  then
	target = GAMESTATE:Env()["ScoreTargets"][Player].score
	targetName = GAMESTATE:Env()["ScoreTargets"][Player].username
end
local itemSpacing = 58

local PaceBG = LoadModule("UI/UI.ButtonBox.lua")(barWidth*4 + 20,barHeight+90,2,Player,true)

local t = Def.ActorFrame{
	InitCommand = function(self)
		local boosted = function (color,boost)
			return BoostColor( ColorLightTone(color), boost )
		end

		PaceBG:ChangeColor( boosted(PlayerColor(Player),1.25), boosted(PlayerColor(Player),0.25) )

		local cPl = self:GetChild("Player"):GetChildren()
		cPl.Progress:zoomto( barWidth, barHeight ):croptop(1):diffuse(PlayerColor(Player))
		cPl.ProgressBG:zoomto( barWidth+2, barHeight+2 ):diffuse(PlayerColor(Player)):diffusealpha(0.25)
		cPl.Label:uppercase(true):zoom(0.4)
		:settext( PROFILEMAN:GetProfile(Player):GetDisplayName() ):diffuse(boosted(PlayerColor(Player),1.5)):y( barHeight*.5 + 24 )
		self:GetChild("Player"):x(-itemSpacing)

		-- Record, what is defined as the record set for the chart.
		self:GetChild("Target"):x(itemSpacing)

		local c = self:GetChild("Target"):GetChildren()
		c.Progress:zoomto( barWidth, barHeight ):diffuse(Color.Green):croptop(1)
		c.ProgressBG:zoomto( barWidth+2, barHeight+2 ):diffuse(Color.Green):diffusealpha(0.25)
		c.Label:uppercase(true):zoom(0.4)
		:settext( targetName ):y( barHeight*.5 + 24 ):diffuse( boosted(Color.Green,1.5) )

	end,
	-- Perform all operations for calculation here.
	JudgmentMessageCommand = function(self,param)
		if param.Player == Player then
			local stats = STATSMAN:GetCurStageStats():GetPlayerStageStats(Player)
			if stats then
				local cur,pos = stats:GetCurrentPossibleDancePoints(),stats:GetPossibleDancePoints()
				local calc = (stats:GetActualDancePoints()/pos)
				local set = (cur / pos) * target

				self:GetChild("Player"):GetChild("Progress"):croptop( 1 - calc )
				self:GetChild("Target"):GetChild("Progress"):croptop( 1 - set )
			end
		end
	end,

	PaceBG:Create(),

	Def.ActorFrame{
		Name="Player",
		Def.Quad{ Name="ProgressBG" },
		Def.Quad{ Name="Progress" },
		Def.BitmapText{ Font="_plex bold", Name="Label" },
	},
	-- Stuff for record
	Def.ActorFrame{
		Name="Target",
		Def.Quad{ Name="ProgressBG" },
		Def.Quad{ Name="Progress" },
		Def.BitmapText{ Font="_plex bold", Name="Label" },
	},
}

local GradeMargins = Def.ActorFrame{}
local numGrades = THEME:GetMetric("PlayerStageStats","NumGradeTiersUsed")
--local maxGradeAchieved = 0
for i = 1,numGrades do
	local gradeMargin = THEME:GetMetric("PlayerStageStats",string.format( "GradePercentTier%02d",i ))
	GradeMargins[#GradeMargins+1] = Def.ActorFrame{
		Name="Grade"..i,
		InitCommand=function(self)
			self:xy( 0, scale( gradeMargin, 0, 1, barHeight*.5, -barHeight*.5 ) )
			self:GetChild("Border"):zoomto( itemSpacing*4, 2 )
			-- TODO: Letter on top of line. Maybe make entire graph bigger.
		end,
		JudgmentMessageCommand = function(self,param)
			if param.Player == Player then
				local stats = STATSMAN:GetCurStageStats():GetPlayerStageStats(Player)
				if stats and stats:GetPercentDancePoints() > gradeMargin then
					self:diffuse(Color.Yellow)
					--maxGradeAchieved = i
				end
			end
		end,
		Def.Quad{Name="Border"},
		Def.BitmapText{Font="Common Normal",Name="Grade"},
	}
end
t[#t+1] = GradeMargins
-- ???: There could be a possibility that someone wants to get a max grade so uhh.
-- local currentMaxGrade = 0

return t