local pn = ...

return Def.ActorFrame{
	Def.Sprite{ Name="Base", Texture=THEME:GetPathG("","Gameplay/ProfileArea"),
		InitCommand=function(self)
			self:diffuse( PlayerColor(pn) )
		end
	},

	--[[ Difficulty ]]
	Def.ActorFrame{
		InitCommand=function(self)
			self:xy( self:GetParent():GetChild("Base"):GetZoomedWidth()*.5 - 4, -1 )
			self.width = 38
		end,
		["CurrentSteps"..ToEnumShortString(pn).."ChangedMessageCommand"]=function(self) self:playcommand("Set") end,
		SetCommand=function(self)
			local c = self:GetChildren()
			local steps_data = GAMESTATE:GetCurrentSteps(pn)
			if GAMESTATE:GetCurrentSong() and steps_data then
				LoadModule("Color.CustomDiffToColor.lua")(c.BG, steps_data)
				c.Number:settext(string.format("%.4g",steps_data:GetMeter()))
			end
		end,
		Def.Quad { Name="BG", OnCommand=function(self) self:zoomto(self:GetParent().width,36):halign(1) end },
		Def.BitmapText {
			Name="Number", Font="_Plex Numbers 40px",
			OnCommand=function(self) self:maxwidth(40/0.75):diffusealpha(.75):zoom(.6):x( -self:GetParent().width*.5 ) end
		}
	},
	
	-- Avatar
	Def.Sprite {
		Texture=LoadModule("Options.GetProfileData.lua")(pn)["Image"],
		InitCommand=function(self) self:xy( -self:GetParent():GetChild("Base"):GetZoomedWidth()*.25, -1 ):zoomto(36,36) end
	}
}