local ColorTable = LoadModule("Theme.Colors.lua")()
local gc = Var("GameCommand")
local string_name = gc:GetText()
local string_expl = THEME:GetString(Var "LoadingScreen", gc:GetName().."Explanation")

return Def.ActorFrame {
	Def.ActorFrame {
		OnCommand=function(self) self:diffusealpha(0):decelerate(0.3):diffusealpha(1) end,
		OffCommand=function(self) self:linear(0.35):diffusealpha(0):zoom(0.9) end,
		Def.Sprite {
			Texture = THEME:GetPathG("ScreenMenu", "large button base"),
			InitCommand=function(self)
				self:diffuse( ColorTable["MenuButtonGradient"] )
				:diffusetopedge( ColorTable["MenuButtonBase"] )
				:zoom(0.75)
			end,
			GainFocusCommand=function(self) self:stoptweening():linear(0.08)
				:diffuse( ColorTable["MenuButtonGradient"] ):diffusetopedge( ColorTable["MenuButtonBase"] ):diffusealpha(1)  end,
			LoseFocusCommand=function(self) self:stoptweening():linear(0.08)
				:diffuse( ColorDarkTone(ColorTable["MenuButtonGradient"] )):diffusetopedge( ColorDarkTone(ColorTable["MenuButtonBase"]) ):diffusealpha(0.5) end
		},
		Def.Sprite {
			Texture = THEME:GetPathG("ScreenMenu", "large button border"),
			InitCommand=function(self)
				self:diffuse( ColorTable["MenuButtonBorder"] ):zoom(0.75)
			end,
			GainFocusCommand=function(self) self:diffuse( ColorLightTone(ColorTable["MenuButtonBorder"]) ) end,
			LoseFocusCommand=function(self) self:diffuse( ColorTable["MenuButtonBorder"] ) end
		},
		Def.Sprite {
			Texture = THEME:GetPathG("PlayMode", gc:GetText()),
			InitCommand=function(self)
				self:diffuse( ColorTable["MenuButtonText"] ):zoom(0.5):x(-260)
			end,
			GainFocusCommand=function(self) self:stoptweening():linear(0.08):diffusealpha(1) end,
			LoseFocusCommand=function(self) self:stoptweening():linear(0.08):diffusealpha(0.25) end
		},
		-- Text
		Def.BitmapText {
			Font="_Large",
			Text=string_name,
			InitCommand=function(self)
				self:zoom(0.8):maxwidth(650*0.8):horizalign(left):x(-170):y(-14)
				:diffuse( ColorTable["MenuButtonText"] )
			end
		},
		Def.BitmapText {
			Font="_Regular",
			Text=string_expl,
			InitCommand=function(self)
				self:maxwidth(650*0.75):zoom(1):horizalign(left):x(-170):y(16)
				:diffuse( ColorTable["MenuButtonText"] )
			end
		},
		Def.Sprite {
			Texture = THEME:GetPathG("ScreenMenu", "large button base"),
			InitCommand=function(self) self:diffuse(color("#666666")) end,
			DisabledCommand=function(self) self:diffuse(color("0,0,0,0.6")) end,
			EnabledCommand=function(self) self:diffuse(color("1,1,1,0")) end
		}
	},
	-- Shine
	Def.Sprite {
		Texture = THEME:GetPathG("ScreenMenu", "large button base"),
		InitCommand=function(self)
			self:diffuse( ColorLightTone(ColorTable["MenuButtonBorder"] ))
			:zoom(0.75):diffusealpha(0)
		end,
		OffCommand=function(self)
			self:diffusealpha(0.75):linear(0.15):diffusealpha(0)
		end,
		GainFocusCommand=function(self) self:visible(true) end,
		LoseFocusCommand=function(self) self:visible(false) end
	}
}
