return function( args )
	local pn = args.Player
	local isOnline = args.isOnline or false
	local width = args.Width
	-- Create top player bar
	local t = Def.ActorFrame{
		InitCommand=function(self) self:y( 30 ) end,
		OnCommand=function(self)
			self:playcommand("Load")
			local c = self:GetChildren()
			c.ProfileBG:diffuse( Alpha(PlayerColor(pn), 0.8) ):zoom(
				LoadModule("Lua.Resize.lua")(
					c.ProfileBG:GetZoomedWidth(),
					c.ProfileBG:GetZoomedHeight(),
					width,
					c.ProfileBG:GetZoomedHeight()
				)
			)

			c.ProfileIMG:x( -c.ProfileBG:GetZoomedWidth() * .5 + 30 )
			c.ProfileName:x( -c.ProfileBG:GetZoomedWidth() * .5 + 60 )
			if c.OnlineStatus then
				c.OnlineStatus:x( c.ProfileBG:GetZoomedWidth() * .5 - 30 )
			end
			if GAMESTATE:IsPlayerEnabled(pn) then
				self:playcommand("UpdateStepInfo",{ pn = pn, Steps = GAMESTATE:GetCurrentSteps(pn) })
			end
		end,
		LoadCommand=function(self)
			local playerdata = LoadModule("Options.GetProfileData.lua")(pn)
			self:GetChild("ProfileIMG"):Load( playerdata["Image"] ):zoomto(38,38)
			self:GetChild("ProfileName"):settext( playerdata["Name"] ):Regen()
			-- :MainActor():customtexturerect(0,0,1,1):texcoordvelocity(0.05,0):fadeleft(0.01):faderight(0.01)
		end,
		StepsChangedMessageCommand=function(self,params)
			self:playcommand("UpdateStepInfo",{ pn = params.pn, Steps = params.Steps })
		end,
	}

	t[#t+1] = LoadModule("Object.GenCornerBox.lua"){
		Width = args.Width*2 - 50,
		Height = 40,
		Corners = {false,false,false,true}
	}..{
		Name="ProfileBG",
		OnCommand=function(self)
			self:y(0):zoom(0.5)
		end
	}
	-- t[#t+1] = Def.Sprite{ Texture=THEME:GetPathG("","UI/PlayerAreaSimple"), Name="ProfileBG" }
	t[#t+1] = Def.Sprite{ Name="ProfileIMG" }

	t[#t+1] = Def.Text{
		Name="ProfileName",
		Font=THEME:GetPathF("","IBMPlexSans-Bold.ttf"),
		Size=24,
		InitCommand=function(self)
			self:MainActor():halign(0)
			self:StrokeActor():halign(0)
			self:xy(48, 6):diffuse(Color.Yellow)
		end
	}

	t[#t+1] = Def.ActorFrame{
		Name="OnlineStatus",
		Condition=isOnline and PROFILEMAN:GetProfile(pn):IsOnlineRegistered(),
		Def.Sprite{
			Texture=THEME:GetPathG("OnlineStatus","online"),
			InitCommand=function(self)
				self:zoom(0.6)
			end
		}
	}

	return t
end