local allowednotes = {
	["TapNoteType_Tap"] = true,
	["TapNoteType_Lift"] = true,
	-- Support the heads of the subtypes.
	["TapNoteSubType_Hold"] = true,
	["TapNoteSubType_Roll"] = true,
	-- Stamina players: you'd want to comment this out.
	["TapNoteType_HoldTail"] = true,
}

local eval_radar = { 'Holds', 'Rolls', 'Hands', 'Mines', 'Lifts' }

return function(Steps,pn)
    if not Steps then return nil end

    for _,v in ipairs( eval_radar) do
        if Steps:GetRadarValues(pn):GetValue("RadarCategory_"..v) > 9999 then
            print("RadarCategory_"..v.." To Many Notes.")
            return 0,{},{},0
        end
    end

    -- let the engine calculate these.
    local n = {
        Density = Steps:GenerateDensityDataForSteps(),
        StreamMeasures = Steps:GenerateStreamMeasures(),
        PeakNPS = Steps:GetMaxNPS(),
        MeasureCount = Steps:GetNumDensityMeasures() -- Keep track of the measure
    }
    
    -- Calculate an average NPS with the generated data.
    local avgNPS = 0
    local c = 0
    for k,v in ipairs(n.Density) do
        -- Don't count entries that have no notes at all, as that will make the
        -- result smaller that it should be.
        if v ~= 0 then
            avgNPS = avgNPS + v
            c = c + 1
        end
    end
    avgNPS = avgNPS / c

    n.AverageNPS = avgNPS

    return n.PeakNPS,n.Density,n.StreamMeasures,n.MeasureCount
end